<template>
  <div>
    <h3>Change password</h3>
    <v-divider class="mb-6"></v-divider>
    <v-form ref="form" v-model="valid" lazy-validation>
      <v-text-field
        v-model="model.old"
        outlined
        required
        label="Old password"
        :rules="passwordRules"
      ></v-text-field>
      <v-text-field
        v-model="model.new"
        outlined
        required
        label="New password"
        :rules="passwordRules"
      ></v-text-field>
      <v-text-field
        v-model="model.newConfirm"
        outlined
        required
        label="Confirm new password"
        :rules="confirmRules"
      ></v-text-field>
      <v-btn @click="clear">Clear</v-btn>
      <v-btn color="primary" :disabled="!valid" @click="submit">Submit</v-btn>
    </v-form>
  </div>
</template>

<script lang="ts">
import Vue from 'vue'

export default Vue.extend({
  data: () => ({
    valid: true,
    model: {
      old: '',
      new: '',
      newConfirm: '',
    },
    passwordRules: [(v: string) => !!v || 'This field is required'],
  }),
  computed: {
    confirmRules() {
      return [
        (v: string) => !!v || 'This field is required',
        (v: string) =>
          v === this.model.new || 'Password confirmation must match',
      ]
    },
  },
  methods: {
    clear(): void {
      ;(this.$refs.form as any).reset()
    },
    submit(): void {
      if ((this.$refs.form as any).validate()) {
        // TODO: AXIOS submit
      }
    },
  },
})
</script>
